/*********************************************************/
/* TAUCS                                                 */
/* Author: Sivan Toledo                                  */
/*********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>
#include "taucs.h"

#define RNDM ((double)random()/(double)RAND_MAX);

#define max(x,y) ( ((x) > (y)) ? (x) : (y) )

/*********************************************************/
/*                                                       */
/*********************************************************/

#if 0
symccs_matrix* 
taucs_symccs_create(int n, int nnz)
{
  symccs_matrix*  m;
  int i,j,k;

  m = (symccs_matrix*) malloc(sizeof(symccs_matrix));
  if (!m) { 
    	taucs_printf("symccs_allocate: out of memory (3)\n");
	return NULL; 
  }
  m->uplo = ' ';
  /*m->indshift = 0;*/
  m->n = n;
  m->colptr = (int*)    malloc((n+1) * sizeof(int));
  m->rowind = (int*)    malloc(nnz   * sizeof(int));
  m->values = (double*) malloc(nnz   * sizeof(double));
  if (!(m->colptr) || !(m->rowind) || !(m->rowind)) {
    	taucs_printf("symccs_allocate: out of memory (4): n=%d nnz=%d\n",n,nnz);
	free(m->colptr); free(m->rowind); free(m->values);
	free (m);
	return NULL; 
  }

  return m;
} 

void 
taucs_symccs_free(symccs_matrix* m)
{
  free(m->rowind);
  free(m->colptr);
  free(m->values);
  free(m);
}
#endif
/*********************************************************/
/* CCS                                                   */
/*********************************************************/

taucs_ccs_matrix* 
taucs_ccs_create(int m, int n, int nnz)
{
  taucs_ccs_matrix* matrix;
  int i,j,k;

  matrix = (taucs_ccs_matrix*) malloc(sizeof(taucs_ccs_matrix));
  if (!matrix) { 
    taucs_printf("taucs_ccs_create: out of memory\n");
    return NULL; 
  }
  matrix->flags = 0;;
  matrix->n = n;
  matrix->m = m;
  matrix->colptr = (int*)    malloc((n+1) * sizeof(int));
  matrix->rowind = (int*)    malloc(nnz   * sizeof(int));
  matrix->values = (double*) malloc(nnz   * sizeof(double));
  if (!(matrix->colptr) || !(matrix->rowind) || !(matrix->rowind)) {
    taucs_printf("taucs_ccs_create: out of memory (n=%d, nnz=%d)\n",n,nnz);
    free(matrix->colptr); free(matrix->rowind); free(matrix->values);
    free (matrix);
    return NULL; 
  }

  return matrix;
} 

void 
taucs_ccs_free(taucs_ccs_matrix* matrix)
{
  free(matrix->rowind);
  free(matrix->colptr);
  free(matrix->values);
  free(matrix);
}

/*********************************************************/
/*                                                       */
/*********************************************************/

